package require MODDBC
package provide MODDBC_Postgres 1.0

proc pg_initcmd {} {
  load /usr/lib/libpgtcl.so.1
}

proc pg_destroycmd {} {
}

proc pg_connectcmd {db_name host port user password} {
  set handle [pg_connect $db_name -host $host -port $port]
  return $handle
}

proc pg_disconnectcmd {handle} {
  pg_disconnect $handle
}

proc pg_sqlcmd {handle cmd} {
  global ntups
  global sqlres
  global tupi

  set sqlres [pg_exec $handle $cmd]
  set ntups [pg_result $sqlres -numTuples]
  set tupi 0
}

proc pg_nextcmd {handle} {
  global ntups
  global sqlres
  global tupi

  if {$tupi==$ntups} {
    return ""
  }
  set res [pg_result $sqlres -getTuple $tupi]
  incr tupi
  return $res
}

proc pg_colnamecmd {handle} {
  global sqlres

  return [pg_result $sqlres -attributes]
}

proc pg_coltypecmd {handle} {
  return ""
}

proc pg_colsizecmd {handle} {
  return ""
}

db_register pg pg_initcmd pg_destroycmd pg_connectcmd \
            pg_disconnectcmd pg_sqlcmd pg_nextcmd pg_colnamecmd \
            pg_coltypecmd pg_colsizecmd
